刷力扣热题–第七天:560 和为k的子数组
菜鸟第六天开始奋战敲代码,持之以恒,见证成长
1.题目简介
2.题目解答
这道题第一想法是通过一次遍历,获取第一个元素的一个子集,以此类推~
错题集一(可不看QAQ)
很好,题目理解错了~题目要找的是整个数组内的和为k的子数组个数,那么每一遍遍历的时候,去找那些连续的数加和为k,那么循环做起来就很方便了发现为k就继续计算,再算上它本身。
暴力求解
虽然知道暴力解题,最后必超时,但还是写了。不然机试拿到这道题真的就寄了。优化一下~
说实话,我自己的话想不到,它涉及到字符串前缀问题,会用到哈希也就是字典,看了几种解法,解题过程都相对复杂,我想还是得把前缀和的题刷过才能明白,简要解释一下,遇到特定题再好好记一下。
哈希求解
3.心得体会
最近做这几道题感觉越来越吃力了,可能数据结构忘得多了,一边写一边补吧~
暴力的代码:
class Solution(object):
def subarraySum(self, nums, k):
"""
:type nums: List[int]
:type k: int
:rtype: int
"""
l = 0
r = 1
length = 0
sum_add = 0
while l < len(nums):
sum_add += sum_add + nums[l]
if sum_add == k:
length += 1
while r < len(nums):
sum_add += nums[r]
if sum_add == k:
length += 1
r += 1
l += 1
r = l + 1
sum_add = 0
return length
哈希的代码:
class Solution(object):
def subarraySum(self, nums, k):
"""
:type nums: List[int]
:type k: int
:rtype: int
"""
length = 0
sum_add = {}
temp = 0
for i in nums:
temp += i
if temp == k:
length += 1
if temp - k in sum_add:
length += sum_add[temp-k]
sum_add[temp] = sum_add.get(temp, 0) + 1
return length
4.做题时长
7-10-10:35 == 7-10-11:15 这是暴力解题,先吊口气在这~